﻿using System;
using System.Workflow.ComponentModel;

using BA.WorkflowServices.Demos.Contracts;

namespace BA.WorkflowServices.Demos.Activities
{
	public partial class GetProductQuote: Activity
    {
        #region Constructors

        public GetProductQuote()
		{
			InitializeComponent();
        }

        #endregion

        #region Dependency Properties

        public static DependencyProperty ProductIdProperty = DependencyProperty.Register("ProductId", typeof(Int32), typeof(GetProductQuote));
        public static DependencyProperty QuoteProperty = DependencyProperty.Register("Quote", typeof(PriceQuote), typeof(GetProductQuote));

        [System.ComponentModel.DescriptionAttribute("ProductId")]
        [System.ComponentModel.CategoryAttribute("ProductId Category")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public Int32 ProductId
        {
            get
            {
                return ((Int32)(base.GetValue(GetProductQuote.ProductIdProperty)));
            }
            set
            {
                base.SetValue(GetProductQuote.ProductIdProperty, value);
            }
        }

        [System.ComponentModel.DescriptionAttribute("Quote")]
        [System.ComponentModel.CategoryAttribute("Quote Category")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public PriceQuote Quote
        {
            get
            {
                return ((PriceQuote)(base.GetValue(GetProductQuote.QuoteProperty)));
            }
            set
            {
                base.SetValue(GetProductQuote.QuoteProperty, value);
            }
        }

        #endregion

        #region Virtual Method Overrides

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            Quote = new PriceQuote();
            Quote.ProductId = ProductId;

            // look up the price
            Quote.Price =
                ProductId < 0 ? -1.00M :
                ProductId < 100 ? 1.99M :
                ProductId < 200 ? 150.95M :
                ProductId < 500 ? 9999.99M :
                0.00M;
            
            return base.Execute(executionContext);
        }

        #endregion
    }
}
