﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

using BA.WorkflowServices.Demos.Contracts;

namespace BA.WorkflowServices.Demos.WorkflowServices
{
    public sealed partial class ProductDistributor : StateMachineWorkflowActivity
    {
        public Int32 CurrentProductId = default(System.Int32);

        public static DependencyProperty CurrentQuoteProperty = DependencyProperty.Register("CurrentQuote", typeof(PriceQuote), typeof(ProductDistributor));

        [DescriptionAttribute("CurrentQuote")]
        [CategoryAttribute("CurrentQuote Category")]
        [BrowsableAttribute(true)]
        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        public PriceQuote CurrentQuote
        {
            get
            {
                return ((PriceQuote)(base.GetValue(ProductDistributor.CurrentQuoteProperty)));
            }
            set
            {
                base.SetValue(ProductDistributor.CurrentQuoteProperty, value);
            }
        }

        public static DependencyProperty QuotesProperty = DependencyProperty.Register("Quotes", typeof(List<PriceQuote>), typeof(ProductDistributor));

        [DescriptionAttribute("Quotes")]
        [CategoryAttribute("Parameters")]
        [BrowsableAttribute(true)]
        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        public List<PriceQuote> Quotes
        {
            get
            {
                return ((List<PriceQuote>)(base.GetValue(ProductDistributor.QuotesProperty)));
            }
            set
            {
                base.SetValue(ProductDistributor.QuotesProperty, value);
            }
        }

        public ProductDistributor()
        {
            InitializeComponent();
        }

        private void createOrder_ExecuteCode(object sender, EventArgs e)
        {
            Quotes = new List<PriceQuote>();
        }

        private void addProduct_ExecuteCode(object sender, EventArgs e)
        {
            Quotes.Add(CurrentQuote);
        }

    }
}
